#include <plasp/utils/Logger.h>

#include <plasp/utils/ParserWarning.h>

namespace plasp
{
namespace utils
{

////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Logger
//
////////////////////////////////////////////////////////////////////////////////////////////////////

Logger::Logger()
:	m_isPedantic{false}
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void Logger::setPedantic(bool isPedantic)
{
	m_isPedantic = isPedantic;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void Logger::parserWarning(const Parser &parser, const std::string &message)
{
	if (m_isPedantic)
		throw ParserWarning(parser, message);

	const auto coordinate = parser.coordinate();

	std::cerr << "Warning: " << coordinate.sectionName << ":"
		<< std::to_string(coordinate.row) + ":" + std::to_string(coordinate.column)
		<< " " << message << std::endl;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

}
}
